unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DrufelSMPPDemo, StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    DrufelSMPPDemo1: TDrufelSMPPDemo;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Button1: TButton;
    Button2: TButton;
    Panel4: TPanel;
    Panel5: TPanel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button13: TButton;
    Button14: TButton;
    procedure Button14Click(Sender: TObject);
    procedure DrufelSMPPDemo1Unbind_RESP_Error(Sender: TObject; command_status,
      sequence_number: Cardinal);
    procedure DrufelSMPPDemo1Submit_SM_RESP_Error(Sender: TObject; command_status,
      sequence_number: Cardinal; message_id: string);
    procedure Button13Click(Sender: TObject);
    procedure DrufelSMPPDemo1Connecting(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure DrufelSMPPDemo1Unknown_command(Sender: TObject; command_length,
      command_id, command_status, sequence_number: Cardinal;
      Parameters: string);
    procedure DrufelSMPPDemo1Generic_NACK(Sender: TObject; command_status,
      sequence_number: Cardinal);
    procedure DrufelSMPPDemo1Replace_RESP_Error(Sender: TObject; command_status,
      sequence_number: Cardinal);
    procedure DrufelSMPPDemo1Replace_RESP_OK(Sender: TObject;
      sequence_number: Cardinal);
    procedure Button10Click(Sender: TObject);
    procedure DrufelSMPPDemo1Cancel_RESP_Error(Sender: TObject; command_status,
      sequence_number: Cardinal);
    procedure DrufelSMPPDemo1Cancel_RESP_OK(Sender: TObject;
      sequence_number: Cardinal);
    procedure Button9Click(Sender: TObject);
    procedure DrufelSMPPDemo1Query_SM_RESP_Error(Sender: TObject; command_status,
      sequence_number: Cardinal; message_id, final_date: string; message_state,
      error_code: Byte);
    procedure DrufelSMPPDemo1Query_SM_RESP_OK(Sender: TObject;
      sequence_number: Cardinal; message_id, final_date: string; message_state,
      error_code: Byte);
    procedure Button8Click(Sender: TObject);
    procedure DrufelSMPPDemo1Enquire_LINK(Sender: TObject; command_status,
      sequence_number: Cardinal);
    procedure DrufelSMPPDemo1SockError(Sender: TObject; ErrorCode: Integer);
    procedure DrufelSMPPDemo1Data_SM(Sender: TObject; sequence_number: Cardinal;
      service_type: string; source_addr_ton, source_addr_npi: Byte;
      source_addr: string; dest_addr_ton, dest_addr_npi: Byte;
      destination_addr: string; esm_class, registered_delivery,
      data_coding: Byte; OPData_SM: TOPData_SM);
    procedure DrufelSMPPDemo1Data_SM_RESP_Error(Sender: TObject; command_status,
      sequence_number: Cardinal; message_id: string;
      OPData_SM_RESP: TOPData_SM_RESP);
    procedure DrufelSMPPDemo1Data_SM_RESP_OK(Sender: TObject;
      sequence_number: Cardinal; message_id: string;
      OPData_SM_RESP: TOPData_SM_RESP);
    procedure Button7Click(Sender: TObject);
    procedure DrufelSMPPDemo1Enquire_LINK_RESP(Sender: TObject; command_status,
      sequence_number: Cardinal);
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure DrufelSMPPDemo1Unbind_RESP_OK(Sender: TObject;
      sequence_number: Cardinal);
    procedure DrufelSMPPDemo1Disconnect(Sender: TObject);
    procedure DrufelSMPPDemo1Submit_SM_RESP_OK(Sender: TObject;
      sequence_number: Cardinal; message_id: string);
    procedure Button4Click(Sender: TObject);
    procedure DrufelSMPPDemo1Submit_MULTI_RESP_OK(Sender: TObject;
      sequence_number: Cardinal; message_id: string; no_unsuccess: Byte;
      unsuccess_sme: Tunsuccess_sme);
    procedure Button3Click(Sender: TObject);
    procedure DrufelSMPPDemo1Submit_MULTI_RESP_Error(Sender: TObject;
      command_status, sequence_number: Cardinal; message_id: string;
      no_unsuccess: Byte; unsuccess_sme: Tunsuccess_sme);
    procedure DrufelSMPPDemo1Deliver_SM(Sender: TObject; sequence_number: Cardinal;
      service_type: string; source_addr_ton, source_addr_npi: Byte;
      source_addr: string; dest_addr_ton, dest_addr_npi: Byte;
      destination_addr: string; esm_class, protocol_id, priority_flag: Byte;
      schedule_delivery_time, validity_period: string; registered_delivery,
      replace_if_present_flag, data_coding, sm_default_msg_id, sm_length: Byte;
      short_message: string; OPDeliver_SM: TOPDeliver_SM);
    procedure DrufelSMPPDemo1Connect(Sender: TObject);
    procedure DrufelSMPPDemo1Bind_RESP_Error(Sender: TObject;
      Bind_Type: TBindType; command_status, sequence_number: Cardinal;
      system_id: string;OPBind_RESP:TOPBind_RESP);
    procedure DrufelSMPPDemo1Bind_RESP_OK(Sender: TObject; Bind_Type: TBindType;
      sequence_number: Cardinal; system_id: string;OPBind_RESP:TOPBind_RESP);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
DrufelSMPPDemo1.Connect('192.0.1.60',2000);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
DrufelSMPPDemo1.Unbind
end;

procedure TForm1.DrufelSMPPDemo1Bind_RESP_OK(Sender: TObject;
  Bind_Type: TBindType; sequence_number: Cardinal;
  system_id: string; OPBind_RESP:TOPBind_RESP);
begin
ListBox1.Items.Add('Bind_RESP_OK sc_interface_version:'+IntToHex(OPBind_RESP.sc_interface_version.Value,2))
end;

procedure TForm1.DrufelSMPPDemo1Bind_RESP_Error(Sender: TObject;
  Bind_Type: TBindType; command_status, sequence_number: Cardinal;
  system_id: string; OPBind_RESP:TOPBind_RESP);
begin
ListBox1.Items.Add('Bind_RESP_Error command_status:'+IntToStr(command_status))
end;

procedure TForm1.DrufelSMPPDemo1Connect(Sender: TObject);
begin
//DrufelSMPP1.Bind(Transceiver,'Term_02','berkut','BercTerm',0,1,'001')
ListBox1.Items.Add('Connect. Press Bind.');
//TDrufelSMPP(Sender).Bind(Transceiver,'Term_02','berkut','BercTerm',0,1,'001')
//TDrufelSMPP(Sender).Disconnect
end;

procedure TForm1.DrufelSMPPDemo1Deliver_SM(Sender: TObject;
  sequence_number: Cardinal; service_type: string; source_addr_ton,
  source_addr_npi: Byte; source_addr: string; dest_addr_ton,
  dest_addr_npi: Byte; destination_addr: string; esm_class, protocol_id,
  priority_flag: Byte; schedule_delivery_time, validity_period: string;
  registered_delivery, replace_if_present_flag, data_coding, sm_default_msg_id,
  sm_length: Byte; short_message: string; OPDeliver_SM: TOPDeliver_SM);
//var
//OPSubmit_SM:TOPSubmit_SM;
begin
TDrufelSMPPDemo(Sender).Deliver_SM_RESP(0,sequence_number,'');
//ListBox2.Items.Add('Submit_SM:'+IntToStr(DrufelSMPP1.Submit_SM('',0,1,'001',0,1,'001',0,0,0,'','',0,0,4,0,' ',OPSubmit_SM)));
ListBox2.Items.Add('Deliver_SM_RESP From:'+source_addr+' to:'+destination_addr+' message:'+short_message)
//ListBox2.Items.Add(':'+source_addr+' :'+destination_addr+' :'+
//OPDeliver_SM.message_payload.Value)
end;

procedure TForm1.DrufelSMPPDemo1Submit_MULTI_RESP_Error(Sender: TObject;
  command_status, sequence_number: Cardinal; message_id: string;
  no_unsuccess: Byte; unsuccess_sme: Tunsuccess_sme);
begin
ListBox2.Items.Add('Submit_MULTI_RESP_Error command_status:'+IntToStr(command_status)+' no_unsuccess:'+IntToStr(no_unsuccess))
end;

procedure TForm1.Button3Click(Sender: TObject);
var
dest_address:Tdest_address;
OPSubmit_MULTI:TOPSubmit_MULTI;
begin
DrufelSMPPDemo1.dest_address_AddSME(dest_address,1,1,'79022880210');
DrufelSMPPDemo1.dest_address_AddSME(dest_address,1,1,'79022880210');
DrufelSMPPDemo1.Submit_MULTI('',5,0,'DrufelSMPP',dest_address,0,0,0,'','',0,0,0,0,'Test Submit_MULTI from DrufelSMPP',OPSubmit_MULTI)
//DrufelSMPPDemo1.Submit_MULTI('',0,1,'001',dest_address,0,0,0,'','',0,0,0,0,'Test Submit_MULTI from DrufelSMPP',OPSubmit_MULTI)
end;

procedure TForm1.DrufelSMPPDemo1Submit_MULTI_RESP_OK(Sender: TObject;
  sequence_number: Cardinal; message_id: string; no_unsuccess: Byte;
  unsuccess_sme: Tunsuccess_sme);
begin
ListBox2.Items.Add('Submit_MULTI_RESP_OK:'+' no_unsuccess:'+IntToStr(no_unsuccess))
end;

procedure TForm1.Button4Click(Sender: TObject);
var
OPSubmit_SM:TOPSubmit_SM;
begin
ListBox2.Items.Add('Submit_SM sequence_number:'+IntToStr(DrufelSMPPDemo1.Submit_SM('',5,0,'DrufelSMPP',1,1,'79022880210',0,0,0,'','',0,0,0,0,'Test Submit_SM from DrufelSMPP',OPSubmit_SM)));
ListBox2.Items.Add('Submit_SM sequence_number:'+IntToStr(DrufelSMPPDemo1.Submit_SM('',0,1,'001',1,1,'79022880210',0,0,0,'','',0,0,0,0,'Test Submit_SM from DrufelSMPP',OPSubmit_SM)))
//DrufelSMPPDemo1.Submit_SM('',0,1,'001',1,1,'79022880210',0,0,0,'','',0,0,0,0,'Test Submit_SM from DrufelSMPP',OPSubmit_SM)
end;

procedure TForm1.DrufelSMPPDemo1Submit_SM_RESP_OK(Sender: TObject;
  sequence_number: Cardinal; message_id: string);
begin
ListBox2.Items.Add('Submit_SM_RESP_OK message_id:'+message_id+' sequence_number:'+IntToStr(sequence_number))
end;

procedure TForm1.DrufelSMPPDemo1Disconnect(Sender: TObject);
begin
ListBox1.Items.Add('Disconnect')
//TDrufelSMPP(Sender).Connect('192.0.1.60',2000);
end;

procedure TForm1.DrufelSMPPDemo1Unbind_RESP_OK(Sender: TObject;
  sequence_number: Cardinal);
begin
ListBox1.Items.Add('Unbind_RESP_OK')
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
DrufelSMPPDemo1.Disconnect
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
DrufelSMPPDemo1.Enquire_LINK;
end;

procedure TForm1.DrufelSMPPDemo1Enquire_LINK_RESP(Sender: TObject; command_status,
  sequence_number: Cardinal);
begin
ListBox2.Items.Add('Enquire_LINK_RESP sequence_number:'+IntToStr(sequence_number))
end;

procedure TForm1.Button7Click(Sender: TObject);
var
OPData_SM:TOPData_SM;
begin
OPData_SM.ms_validity.Field:=True;
OPData_SM.ms_validity.Value:=1;
OPData_SM.message_payload.Field:=True;
OPData_SM.message_payload.Value:='Test Data_SM from DrufelSMPP';
DrufelSMPPDemo1.Data_SM('',5,0,'DrufelSMPP',1,1,'79022880210',0,0,0,OPData_SM)
//DrufelSMPPDemo1.Data_SM('',0,1,'001',1,1,'79022880210',0,0,0,OPData_SM)
end;

procedure TForm1.DrufelSMPPDemo1Data_SM_RESP_OK(Sender: TObject;
  sequence_number: Cardinal; message_id: string;
  OPData_SM_RESP: TOPData_SM_RESP);
begin
ListBox2.Items.Add('Data_SM_RESP_OK message_id:'+message_id)
end;

procedure TForm1.DrufelSMPPDemo1Data_SM_RESP_Error(Sender: TObject; command_status,
  sequence_number: Cardinal; message_id: string;
  OPData_SM_RESP: TOPData_SM_RESP);
begin
ListBox2.Items.Add('Data_SM_RESP_Error command_status:'+IntToStr(command_status))
end;

procedure TForm1.DrufelSMPPDemo1Data_SM(Sender: TObject; sequence_number: Cardinal;
  service_type: string; source_addr_ton, source_addr_npi: Byte;
  source_addr: string; dest_addr_ton, dest_addr_npi: Byte;
  destination_addr: string; esm_class, registered_delivery, data_coding: Byte;
  OPData_SM: TOPData_SM);
begin
ListBox2.Items.Add('Data_SM:'+destination_addr)
end;

procedure TForm1.DrufelSMPPDemo1SockError(Sender: TObject; ErrorCode: Integer);
begin
ListBox2.Items.Add('SockError:'+IntToStr(ErrorCode))
end;

procedure TForm1.DrufelSMPPDemo1Enquire_LINK(Sender: TObject; command_status,
  sequence_number: Cardinal);
begin
TDrufelSMPPDemo(Sender).Enquire_LINK_RESP(sequence_number)
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
DrufelSMPPDemo1.Query_SM('1B643B8',0,1,'001')
end;

procedure TForm1.DrufelSMPPDemo1Query_SM_RESP_OK(Sender: TObject;
  sequence_number: Cardinal; message_id, final_date: string; message_state,
  error_code: Byte);
begin
ListBox2.Items.Add('Query_SM_RESP_OK sequence_number:'+IntToStr(sequence_number)+' message_id:'+message_id+
' final_date:'+final_date+' message_state:'+IntToStr(message_state)+'')
end;

procedure TForm1.DrufelSMPPDemo1Query_SM_RESP_Error(Sender: TObject; command_status,
  sequence_number: Cardinal; message_id, final_date: string; message_state,
  error_code: Byte);
begin
ListBox2.Items.Add('Query_SM_RESP_Error command_status:'+IntToStr(command_status))
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
DrufelSMPPDemo1.Cancel_SM('','1B643B8',0,1,'001',1,1,'79022880210')
end;

procedure TForm1.DrufelSMPPDemo1Cancel_RESP_OK(Sender: TObject;
  sequence_number: Cardinal);
begin
ListBox2.Items.Add('Cancel_RESP_OK sequence_number:'+IntToStr(sequence_number))
end;

procedure TForm1.DrufelSMPPDemo1Cancel_RESP_Error(Sender: TObject; command_status,
  sequence_number: Cardinal);
begin
ListBox2.Items.Add('Cancel_RESP_Error command_status:'+IntToStr(command_status)+' sequence_number:'+IntToStr(sequence_number))
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
DrufelSMPPDemo1.Replace_SM('1B64B39',0,1,'001','','',0,0,'The message is changed')
end;

procedure TForm1.DrufelSMPPDemo1Replace_RESP_OK(Sender: TObject;
  sequence_number: Cardinal);
begin
ListBox2.Items.Add('Replace_RESP_OK sequence_number:'+IntToStr(sequence_number))
end;

procedure TForm1.DrufelSMPPDemo1Replace_RESP_Error(Sender: TObject; command_status,
  sequence_number: Cardinal);
begin
ListBox2.Items.Add('Replace_RESP_Error command_status:'+IntToStr(command_status)+' sequence_number:'+IntToStr(sequence_number))
end;

procedure TForm1.DrufelSMPPDemo1Generic_NACK(Sender: TObject; command_status,
  sequence_number: Cardinal);
begin
ListBox2.Items.Add('Generic_NACK command_status:'+IntToStr(command_status)+' sequence_number:'+IntToStr(sequence_number))
end;

procedure TForm1.DrufelSMPPDemo1Unknown_command(Sender: TObject; command_length,
  command_id, command_status, sequence_number: Cardinal; Parameters: string);
begin
ListBox2.Items.Add('Unknown_command:'+IntToStr(command_id)+' command_status:'+IntToStr(command_status)+
' sequence_number:'+IntToStr(sequence_number))
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
ListBox1.Items.Add('Connected:'+BoolToStr(DrufelSMPPDemo1.Connected,True))
end;

procedure TForm1.DrufelSMPPDemo1Connecting(Sender: TObject);
begin
ListBox1.Items.Add('Connecting')
end;

procedure TForm1.Button13Click(Sender: TObject);
begin
DrufelSMPPDemo1.Bind(Transceiver,'system_id','password','system_type',0,1,'001')
end;

procedure TForm1.DrufelSMPPDemo1Submit_SM_RESP_Error(Sender: TObject;
  command_status, sequence_number: Cardinal; message_id: string);
begin
ListBox2.Items.Add('Submit_SM_RESP_Error message_id:'+message_id+'  command_status:'+IntToStr(command_status)+' sequence_number:'+IntToStr(sequence_number))
end;

procedure TForm1.DrufelSMPPDemo1Unbind_RESP_Error(Sender: TObject; command_status,
  sequence_number: Cardinal);
begin
ListBox1.Items.Add('Unbind_RESP_Error command_status:'+IntToStr(command_status))
end;

procedure TForm1.Button14Click(Sender: TObject);
begin
DrufelSMPPDemo1.Generic_NACK(4)
end;

end.
